DEFINT A-Z
'Pasco's floormapper
'source released to public
'July 18, 2000
CONST ips = 32000


SCREEN 0
INPUT "Retrace waiting [y/N] ?"; I$
I$ = UCASE$(LEFT$(I$, 1))
IF I$ = "Y" THEN vwait = 1
SCREEN 13

DIM c AS LONG, s AS LONG
DIM playerx AS LONG, playery AS LONG
DIM dlook(8191), ytable2(63, 100 TO 199), ytable3(63)
DIM tex(63, 63), tex2(63, 63)
'$DYNAMIC
DIM SHARED kbcontrol(1024), kbmatrix(128)
'$STATIC

kbinit = 0
DEF SEG = VARSEG(kbcontrol(0))
BLOAD "keyb.prg", VARPTR(kbcontrol(0))
kbcontrol(128) = VARSEG(kbmatrix(0))
kbcontrol(129) = VARPTR(kbmatrix(0))
CALL ABSOLUTE(&H180)
FOR lp = 0 TO 128
   kbmatrix(lp) = 0
NEXT
kbinit = 1

FOR l = 0 TO 8191
dlook(l) = (l \ 64) AND 63
NEXT

FOR l = 0 TO 63
   OUT &H3C8, l
   OUT &H3C9, l * .75
   OUT &H3C9, l * .25
   OUT &H3C9, 0

   OUT &H3C8, l + 64
   OUT &H3C9, 0
   OUT &H3C9, l
   OUT &H3C9, 0

   OUT &H3C8, l + 128
   OUT &H3C9, l * .25
   OUT &H3C9, l * .75
   OUT &H3C9, 0

   OUT &H3C8, l + 192
   OUT &H3C9, 0
   OUT &H3C9, l
   OUT &H3C9, 0
NEXT
FOR y = 0 TO 63
   FOR x = 0 TO 63
      c = 63 - SQR((x - 31) ^ 2 + (y - 31) ^ 2) / 1.5
      IF c < 0 THEN c = 0
      tex(x, y) = c
      
      c = 63 - SQR((x - 31) ^ 2 + (y - 31) ^ 2) * 3
      IF c < 0 THEN c = 0
      c2 = ABS(x - y)
      IF c2 < 8 THEN c = c + 16 - c2 * 2
      
      c2 = ABS((63 - x) - y)
      IF c2 < 8 THEN c = c + 16 - c2 * 2
      
      d = ABS(20 - SQR((x - 31) ^ 2 + (y - 31) ^ 2))
      IF d <= 4 THEN c = c + 16 - d * 4
      
      d = ABS(28 - SQR((x - 31) ^ 2 + (y - 31) ^ 2))
      IF d <= 3 THEN c = c + 18 - d * 6
      
      IF c > 63 THEN c = 63
      tex2(x, y) = c
     
      
   NEXT
   
NEXT
t! = TIMER

FOR y = 100 TO 199
   FOR l = 0 TO 63
      ytable2(l, y) = l * (y - 99) \ 100
   NEXT
NEXT

DEF SEG = &HA000

xvect = -160
zvect = 100
DIM xpl(100 TO 199)
DIM ypl(100 TO 199)

FOR y = 100 TO 199
   yvect = y - 99
   d! = 10000 / yvect
   xpl(y) = .01 * xvect * d!
   ypl(y) = .01 * zvect * d! - 200
NEXT

DO

kbmatrix(128) = 0
f = f + 1
IF kbmatrix(&H4D) + kbmatrix(&H4B) <> 0 THEN
av = av - kbmatrix(&H4D) + kbmatrix(&H4B)
IF ABS(av) > 50 THEN av = 50 * SGN(av)
ELSE
av = av - SGN(av)
END IF
a = a + av

c = COS(a / 1000) * 128
s = SIN(a / 1000) * 128

IF kbmatrix(&H48) - kbmatrix(&H50) <> 0 THEN

mv = mv + (kbmatrix(&H48) - kbmatrix(&H50)) * 10
IF ABS(mv) > 100 THEN mv = 100 * SGN(mv)
ELSE
mv = mv - SGN(mv)
END IF
IF mv THEN
   playerx = playerx - (s \ 5) * mv
   playery = playery + (c \ 5) * mv
END IF
ps = ips
ps2 = ps - 320
IF vwait THEN WAIT &H3DA, 8
FOR y = 100 TO 199
   xpc = xpl(y) * c \ 64
   xps = xpl(y) * s \ 64
   ypc = ypl(y) * c \ 64
   yps = ypl(y) * s \ 64

   xp1 = xpc - yps + playerx \ 100
   yp1 = xps + ypc + playery \ 100
                  
   xp2 = xp1 - xpc - xpc
   yp2 = yp1 - xps - xps

   xdif = (xp2 - xp1) \ 10
   ydif = (yp2 - yp1) \ 10
   xdif1 = (xdif \ 2) AND 4095
   ydif1 = (ydif \ 2) AND 4095

   xc = xp1 * 16 AND 4095
   yc = yp1 * 16 AND 4095
  
   FOR l = 0 TO 63
      ytable3(l) = ytable2(l, y)
   NEXT

   FOR x = 0 TO 319 STEP 8
      
      POKE ps, ytable3(tex(dlook(xc), dlook(yc)))
      POKE ps + 1, ytable3(tex(dlook(xc + xdif1), dlook(yc + ydif1)))
     
      POKE ps2, ytable3(tex2(dlook(xc), dlook(yc)))
      POKE ps2 + 1, ytable3(tex2(dlook(xc + xdif1), dlook(yc + ydif1)))

      xc2 = xc + xdif AND 4095: yc2 = yc + ydif AND 4095
      POKE ps + 2, ytable3(tex(dlook(xc2), dlook(yc2)))
      POKE ps + 3, ytable3(tex(dlook(xc2 + xdif1), dlook(yc2 + ydif1)))
      POKE ps2 + 2, ytable3(tex2(dlook(xc2), dlook(yc2)))
      POKE ps2 + 3, ytable3(tex2(dlook(xc2 + xdif1), dlook(yc2 + ydif1)))
     
      xc = xc2 + xdif AND 4095: yc = yc2 + ydif AND 4095
      POKE ps + 4, ytable3(tex(dlook(xc), dlook(yc)))
      POKE ps + 5, ytable3(tex(dlook(xc + xdif1), dlook(yc + ydif1)))
      POKE ps2 + 4, ytable3(tex2(dlook(xc), dlook(yc)))
      POKE ps2 + 5, ytable3(tex2(dlook(xc + xdif1), dlook(yc + ydif1)))
     
      xc2 = xc + xdif AND 4095: yc2 = yc + ydif AND 4095
      POKE ps + 6, ytable3(tex(dlook(xc2), dlook(yc2)))
      POKE ps + 7, ytable3(tex(dlook(xc2 + xdif1), dlook(yc2 + ydif1)))
      POKE ps2 + 6, ytable3(tex2(dlook(xc2), dlook(yc2)))
      POKE ps2 + 7, ytable3(tex2(dlook(xc2 + xdif1), dlook(yc2 + ydif1)))
     
      xc = xc2 + xdif AND 4095: yc = yc2 + ydif AND 4095
   
      ps = ps + 8
      ps2 = ps2 + 8

   NEXT
   ps2 = ps2 - 640

NEXT

LOOP UNTIL kbmatrix(1)

COLOR 63: PRINT f / (TIMER - t!)
t! = TIMER: DO: LOOP UNTIL TIMER - t! > 1

crap:
IF kbinit THEN
   DEF SEG = VARSEG(kbcontrol(0))
   CALL ABSOLUTE(&H1B0)
END IF
IF ERR THEN ERROR ERR
END

